
function Draw3D()

Gu.start3d() -- 3D Drawing Start

          -- clear screen
          Gu.clearDepth(0)
          Gu.clear(Gu.COLOR_BUFFER_BIT|Gu.DEPTH_BUFFER_BIT)

          -- setup projection and view matrices
          Gum.matrixMode(Gu.PROJECTION)
          Gum.loadIdentity()
          Gum.perspective(50, 16/9, 2, 150)

          Gum.matrixMode(Gu.VIEW)
          Gum.loadIdentity()

                                                      --3RD PERSON CAMERA--

     if camera_selected == 1 then

          camera.direction = camera.direction + (model.direction - camera.direction) / 15

          camera.heading_x = math.cos (90 - camera.direction)
          camera.heading_z = math.sin (90 - camera.direction)

          model.heading_x = math.cos(90 - model.direction)
          model.heading_z = math.sin(90 - model.direction)
         
          camera.x = camera.x + ((camera.view_x + camera.heading_x * - 6)  - camera.x) / 3
          camera.y = camera.y + ((camera.view_y + camera.heading_y * - 6 + 2)  - camera.y) / 3
          camera.z = camera.z + ((camera.view_z + camera.heading_z * - 6)  - camera.z) / 3
          
          model.x =  model.speed_x
          model.y =  model.speed_y
          model.z =  model.speed_z

          camera.view_x = model.x
          camera.view_y = model.y + 2
          camera.view_z = model.z

          Gum.lookAt(camera.x,camera.y,camera.z, camera.view_x, camera.view_y, camera.view_z,0.0,1.0,0.0)

    end

                                                     --1st PERSON CAMERA--

    if camera_selected == 2 then

          camera.direction = camera.direction + (model.direction - camera.direction) / 15

          camera.heading_x = math.cos (90 - camera.direction)
          camera.heading_z = math.sin (90 - camera.direction)

          model.heading_x = math.cos(90 - model.direction)
          model.heading_z = math.sin(90 - model.direction)

          camera.x = model.x + ((camera.view_x + camera.heading_x * - 6)  - camera.x) / 3
          camera.y = model.y + ((camera.view_y + camera.heading_y * - 6 + 2)  - camera.y) / 3
          camera.z = model.z + ((camera.view_z + camera.heading_z * - 6 )  - camera.z) / 3

          model.x =  model.speed_x
          model.y =  model.speed_y
          model.z =  model.speed_z

          camera.view_x = model.x
          camera.view_y = model.y + 1
          camera.view_z = model.z
          
          Gum.lookAt(camera.x,camera.y,camera.z, camera.view_x, camera.view_y, camera.view_z,0.0,1.0,0.0)
    end

                                                           --CUBE--

    if camera_selected == 1 then

  Gu.enable(Gu.BLEND)
  Gu.blendFunc(Gu.ADD, Gu.SRC_ALPHA, Gu.ONE_MINUS_SRC_ALPHA, 0, 0)
  Gu.enable(Gu.TEXTURE_2D);
  Gu.texImage(test)
  Gu.texFunc(Gu.TFX_MODULATE, Gu.TCC_RGBA)
  Gu.texEnvColor(white)
  Gu.texFilter(Gu.LINEAR, Gu.LINEAR)
  Gu.texScale(-1, -1)
  Gu.texOffset(0,0)
  Gu.ambientColor(white)

          -- setup matrix for cube
          Gum.matrixMode(Gu.MODEL)
          Gum.loadIdentity()

          Gum.translate( model.x, model.y + 1, model.z)


          Gum.rotateXYZ(rot.x* 0.79 *(Gu.PI/180),model.direction + rot.y ,rot.z * 1.32 *(Gu.PI/180))   


          -- draw cube without texture
        --  Gu.disable(Gu.TEXTURE_2D)
          Gum.drawArray(Gu.TRIANGLES, Gu.TEXTURE_32BITF|Gu.COLOR_8888|Gu.VERTEX_32BITF|Gu.TRANSFORM_3D, cube)
    
    end

                                                          --GRID--

           -- setup matrix for grid
           Gum.matrixMode(Gu.MODEL)
           Gum.loadIdentity()
           Gum.translate(0, 0, 0)
          -- Gum.rotateXYZ(rot.x*(Gu.PI/180),rot.y*(Gu.PI/180),rot.z*(Gu.PI/180))

           -- draw grid without texture
           Gu.disable(Gu.TEXTURE_2D)
           Gum.drawArray(Gu.LINES, Gu.COLOR_8888|Gu.VERTEX_32BITF|Gu.TRANSFORM_3D_3D, grid)

Gu.end3d() -- 3D Drawing End

end


function Controls3D()

           pad = Controls.read()

    if pad:up() then
         
           model.speed_x = model.speed_x + model.heading_x * 0.003 * airdrag
           model.speed_y = model.speed_y + model.heading_y * 0.003 * airdrag
           model.speed_z = model.speed_z + model.heading_z * 0.003 * airdrag

    end

    if  pad:down() then
         
           model.speed_x = model.speed_x - model.heading_x * 0.002  * airdrag
           model.speed_y = model.speed_y - model.heading_y * 0.002  * airdrag
           model.speed_z = model.speed_z - model.heading_z * 0.002  * airdrag
           
    end

    if pad:left() then
         
           model.direction = model.direction + 0.04
    end

    if pad:right() then

           model.direction = model.direction - 0.04
    end
   

   if pad:l() then


   end

    if pad:r() then


   end


  --  if pad:cross() then
           
   --       screen:save("screenshot.png")
  --  end
end



function Camera_select()

        if pad:select() and oldpad:select() ~= pad:select() then

               camera_selected = camera_selected + 1
        end
      
        if camera_selected == 1 then
              
               screen:print(16,16,"3rd Person Camera" ,white)
        end

        if camera_selected == 2 then
              
               screen:print(16,16,"1st Person Camera" ,white)
        end

        if camera_selected > max_camera_selected then
             
              camera_selected = 1
      
        elseif camera_selected <= 0 then
                
              camera_selected = max_camera_selected
        end

    screen.waitVblankStart()
    screen.flip()
    screen:clear(color.clear)

         oldpad = pad
end
